#include "AneuMeshLoader.h"
#include <fstream>
#include <algorithm>

void AneuMeshLoader::loadMesh(const std::string& fileName) {
    std::ifstream file(fileName);
    if (!file) {
        throw FileNotFound();
    }
    else std::cout << "File " << fileName << " was opened successfully." << std::endl;


    // 
    int count, dimension;
    file >> count >> dimension;
    Nodes.reserve(count);
    for (int i = 0; i < count; ++i) {
        Node temp;
        file >> temp.m_coordinates[0] >> temp.m_coordinates[1] >> temp.m_coordinates[2];
        temp.m_ID = i + 1;
        temp.m_vertexDot = false;
        Nodes.push_back(std::move(temp));
    }


    // 
    file >> count >> dimension;
    FiniteElements.reserve(count);
    for (int i = 0; i < count; ++i) {
        FiniteElement temp;
        int IDNode;
        file >> temp.m_GeometryAreaID;
        for (int j = 0; j < dimension; ++j) {
            file >> IDNode;
            temp.m_NodeIDs.push_back(IDNode);
        }
        temp.m_FiniteElementID = i + 1;
        FiniteElements.push_back(std::move(temp));
    }


    //  
    file >> count >> dimension;
    BoundaryElements.reserve(count);
    for (int i = 0; i < count; ++i) {
        FiniteElement temp;
        int IDNode;
        file >> temp.m_GeometryAreaID;
        for (int j = 0; j < dimension; ++j) {
            file >> IDNode;
            temp.m_NodeIDs.push_back(IDNode);
        }
        temp.m_FiniteElementID = i + 1;
        BoundaryElements.push_back(std::move(temp));
    }
}








