#pragma once
#include <iostream>
#include <vector>
#include <array>
struct Node {
	int m_ID;
	static constexpr int dim = 3;
	std::array<double, dim> m_coordinates{};
	bool m_vertexDot; 

	Node() = default;
	Node(int, const std::array<double, dim>&, bool);

	friend std::ostream& operator<<(std::ostream&, const Node&);
	friend std::ostream& operator<<(std::ostream&, const std::vector<Node>&);
};

struct FiniteElement {
	int m_FiniteElementID;
	int m_GeometryAreaID;
	std::vector<int> m_NodeIDs;

	friend std::ostream& operator<<(std::ostream&, const FiniteElement&);
	friend std::ostream& operator<<(std::ostream&, const std::vector<FiniteElement>&);

};

struct Edge {
	std::pair<int, int> m_edgeNodes;
	int m_midNode = -1;
	Edge() = default;
	Edge(int, int);
	Edge& operator=(const Edge&);
	bool operator==(const Edge&) const;
};
